#include "mtwin32.h"
#include "LineTrace.h"
#include <math.h>

LineTrace::LineTrace()
{
	m_last_direction_13   = 0;
	m_last_direction_24   = 0;
	m_cur_x       = 0;
	m_cur_y       = 0;
	m_prev_x      = 0;
	m_prev_y      = 0;
	m_inside_size = 1;
	m_road_color  = make_color(0,0,0);
	// ΂ߕ̋Oɋ߂ĂB
	m_oblique_dist_size   = sizeof(m_oblique_dist)/sizeof(m_oblique_dist[0]);
	// 1/2
	double        root2 = sqrt(2.);
	for( int i=0; i< m_oblique_dist_size; i++) {
		m_oblique_dist[i]   = ceil(i/root2); // mɈړł邱Ƃ⏞邽ߋ͐؂グČvZĂB
	}
}

void LineTrace::set_map_bitmap( mt_bitmap& bmp)
{
	m_bmp.clone( bmp);							// Ô߂ɃRs[ۑ
}

/**
 * H̓ݒ肷B
 * ̐FɉĈړB
 */
void LineTrace::set_road_color( uint4 color)
{
	m_road_color  = color;
}

/**
 * ŏ̈ʒuw肷B
 * ̈ʒu ㉺E 4ɈړB
 */
YesNo LineTrace::set_first_position( int x, int y)
{
	mt_assert( x >= 0 && x< m_bmp.get_width());
	mt_assert( y >= 0 && y< m_bmp.get_height());
	if( x < 0 || x>= m_bmp.get_width() ||
			y < 0 || y>= m_bmp.get_height()) {
		return    NO;
	}
	mt_assert( get_pixel_color(x,y) == m_road_color);
	if( get_pixel_color(x,y) != m_road_color) {
		return    NO;
	}
	m_cur_x       = x;
	m_cur_y       = y;
	return    YES;
}

/**
 * ړ̂̑傫w肷B
 */
void LineTrace::set_object_size( int inside_size)
{
	mt_assert( inside_size >= 1);
	mt_assert( inside_size < m_oblique_dist_size);
	if( inside_size >= m_oblique_dist_size) {
		inside_size = m_oblique_dist_size-1;
	}
	m_inside_size = inside_size;
}

/**
 * ݈ʒuwֈړB
 * dir͈ړ Left, Right, Up, Down ̍ŏ̈ꕶňړw肷B
 */
YesNo LineTrace::try_to_move( TCHAR dir)
{
	int           direction;			// ړ
	// ͒l̃`FbN
	if( dir == _T('U') || dir == _T('u')) {	// Up
		direction   = 1;
	}
	else if( dir == _T('D') || dir == _T('d')) {	// Down
		direction   = 3;
	}
	else if( dir == _T('L') || dir == _T('l')) {	// Left
		direction   = 4;
	}
	else if( dir == _T('R') || dir == _T('r')) {	// Right
		direction   = 2;
	}
	else {
		perr( _T("LineTrace::try_to_move(%c): Unknown direction"), dir);
		return    NO;
	}
	//--------------------------------------------------------------------
	// ۂɂ̕Ɉړł邩ǂׂB
	//--------------------------------------------------------------------
	if( is_movable( direction, m_inside_size)) {
		return    move_to( direction); // ړł̂ňړB
	}
	//--------------------------------------------------------------------
	// w肵ɂ͈ړłȂB
	// ̑̕𒲂ׂĂ݂B
	// 815
	// 402
	// 736
	// Ⴆ direction 2w肳ꂽC56𒲂ׂB
	// 2w肳ꂽ̂13𒲂ׂ邱Ƃ͂Ȃ(Ⴄ̂)B
	//--------------------------------------------------------------------
	int           dir1, dir2;
	get_neighbor_direction( direction, dir1, dir2);	// 擾B
	YesNo         yn_move_to_dir1, yn_move_to_dir2;
	yn_move_to_dir1   = is_movable( dir1, m_inside_size);	// ɂ͈ړ邱Ƃo?
	yn_move_to_dir2   = is_movable( dir2, m_inside_size);
	//--------------------------------------------------------------------
	// ɐi߂邩ǂ̑gݍ킹ŏ߂B
	//--------------------------------------------------------------------
	if( yn_move_to_dir1 && yn_move_to_dir2) {
		// ̕ɂiނƂoBߋɐiłɐiށB
		// ߋɐi񂾕
		return    move_to( get_last_neighbor_direction( direction));
	}
	else if( yn_move_to_dir1) {
		// dir2ɐiނƂ͏oȂ̂ł̕ɐiށB
		return    move_to( dir1);
	}
	else if( yn_move_to_dir2) {
		// dir1ɐiނƂ͏oȂ̂ł̕ɐiށB
		return    move_to( dir2);
	}
	else {												// ̕ɂiނƂoȂB
		return    NO;
	}
}

/**
 * w(1-8)ɐiށB
 */
YesNo LineTrace::move_to( int direction)
{
	mt_assert( direction >= 0 && direction <= 8);
	if( direction == 0) return    NO;	// ԍŏ̉\B
	int           cur_x = m_cur_x;
	int           cur_y = m_cur_y;
	switch( direction) {
	case 1:
		m_last_direction_13 = 1;
		cur_x       += 0;
		cur_y       += -1;
		break;
	case 2:
		m_last_direction_24 = 2;
		cur_x       += 1;
		cur_y       += 0;
		break;
	case 3:
		m_last_direction_13 = 3;
		cur_x       += 0;
		cur_y       += 1;
		break;
	case 4:
		m_last_direction_24 = 4;
		cur_x       += -1;
		cur_y       += 0;
		break;
		//------------------------------------------------------------------
		// ȉ͎΂ߕ
		//------------------------------------------------------------------
	case 5:
		m_last_direction_13 = 1;
		m_last_direction_24 = 2;
		cur_x       += 1;
		cur_y       += -1;
		break;
	case 6:
		m_last_direction_13 = 3;
		m_last_direction_24 = 2;
		cur_x       += 1;
		cur_y       += 1;
		break;
	case 7:
		m_last_direction_13 = 3;
		m_last_direction_24 = 4;
		cur_x       += -1;
		cur_y       += 1;
		break;
	case 8:
		m_last_direction_13 = 1;
		m_last_direction_24 = 4;
		cur_x       += -1;
		cur_y       += -1;
		break;
	}
	m_cur_x       = cur_x;
	m_cur_y       = cur_y;
	return    YES;
}

/**
 * direction(1-4)ɋ߂ŉߋɐi񂾕𓾂B
 */
int LineTrace::get_last_neighbor_direction( int direction)
{
	switch( direction) {
	case 1:
		return    m_last_direction_24;
	case 2:
		return    m_last_direction_13;
	case 3:
		return    m_last_direction_24;
	case 4:
		return    m_last_direction_13;
	default:
		mt_assert(0);
		return    0;
	}
}

/**
 * direction(1-8)̕ɋdisti߂邩?
 */
YesNo LineTrace::is_movable( int direction, int dist)
{
	// {͓r𒲂ׂȂ΂ȂȂ̂낤C1sNZړƂǑɍŏIsNZ𒲂ׂB
	// direction==(5,6,7,8)̏ꍇ͎΂ߕɂȂ苗PɃsNZoƂoȂ̂ŁC
	// 悻̈ʒuƂB
	mt_assert( direction >= 1 && direction <= 8);
	int           dx[] = {0, 0, 1, 0,-1};
	int           dy[] = {0,-1, 0, 1, 0};
	int           x = m_cur_x;
	int           y = m_cur_y;
	if( direction >= 1 && direction <= 4) {
		x           += dist*dx[direction];
		y           += dist*dy[direction];
		if( m_road_color == get_pixel_color( x, y)) {
			return    YES;						// iސ͓HƓFȂ̂ŐiނƂoB
		}
		return    NO;								// FႤ̂ł̕ւ͐i߂ȂB
	}
	//--------------------------------------------------------------------
	// 5-8̏̕ꍇƍWl̊֌W͏ɂȂB
	//--------------------------------------------------------------------
	int           dist_x, dist_y;
	get_xy_direction( direction, dist_x, dist_y);
	dist          = m_oblique_dist[dist];
	x           += dist*dist_x;
	y           += dist*dist_y;
	if( m_road_color == get_pixel_color( x, y)) {
		return    YES;						// iސ͓HƓFȂ̂ŐiނƂoB
	}
	return    NO;								// FႤ̂ł̕ւ͐i߂ȂB
}

/**
 * ΂ߕw肵ƂCۂx,yłǂꂾړ邩߂B
 */
void LineTrace::get_xy_direction( int direction, int& dist_x, int& dist_y)
{
	mt_assert( direction >= 5 && direction <= 8);
	switch( direction) {
	case 5:
		dist_x      = 1;
		dist_y      = -1;
		break;
	case 6:
		dist_x      = 1;
		dist_y      = 1;
		break;
	case 7:
		dist_x      = -1;
		dist_y      = 1;
		break;
	case 8:
		dist_x      = -1;
		dist_y      = -1;
		break;
	default:
		dist_x      = dist_y = 0;
	}
}

/**
 * n}̐F擾B
 * ̐FœHǂʂB
 */
uint4 LineTrace::get_pixel_color( int x, int y)
{
	mt_assert( x >= 0 && x< m_bmp.get_width());
	mt_assert( y >= 0 && y< m_bmp.get_height());
	return    m_bmp.get_color( x, y);
}

/**
 * directio(1-4)ɋ߂2߂B
 */
void LineTrace::get_neighbor_direction( int direction, int& dir1, int& dir2)
{
	mt_assert( direction >= 1 && direction <= 4);
	switch( direction) {
	case 1:
		dir1        = 8;
		dir2        = 5;
		break;
	case 2:
		dir1        = 5;
		dir2        = 6;
		break;
	case 3:
		dir1        = 6;
		dir2        = 7;
		break;
	case 4:
		dir1        = 7;
		dir2        = 8;
		break;
	default:
		dir1        = dir2 = 0;
	}
}

#if 0
#include <conio.h>
int mt_main( int argc, cstring argv[])
{
	mt_option opt( _T("cp"), _T(""), argc, argv);
	cstring       path = opt.get_argument(0);
	mt_bitmap     bmp;
	if( bmp.read( path) == NO) {
		pe( _T("Read ERROR %s\n"), (cstring)path);
		return    1;
	}
	LineTrace     lineTrace;
	lineTrace.set_map_bitmap( bmp);
	lineTrace.set_road_color( make_color(255,0,0));
	lineTrace.set_first_position( 22, 18);
	int           c;
	while( (c=getch())) {
		if( c == _T('q') || c == _T('Q')) break;
		if( c == _T('4')) c = _T('L');
		if( c == _T('6')) c = _T('R');
		if( c == _T('8')) c = _T('U');
		if( c == _T('2')) c = _T('D');
		lineTrace.try_to_move( c);
	}
	return 0;
}
#endif
